#---------------------------------------------------------------------------------------------------
# %L                                                                                               -
# chvote-model-converter                                                                           -
# %%                                                                                               -
# Copyright (C) 2016 - 2018 République et Canton de Genève                                         -
# %%                                                                                               -
# This program is free software: you can redistribute it and/or modify                             -
# it under the terms of the GNU Affero General Public License as published by                      -
# the Free Software Foundation, either version 3 of the License, or                                -
# (at your option) any later version.                                                              -
#                                                                                                  -
# This program is distributed in the hope that it will be useful,                                  -
# but WITHOUT ANY WARRANTY; without even the implied warranty of                                   -
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                                     -
# GNU General Public License for more details.                                                     -
#                                                                                                  -
# You should have received a copy of the GNU Affero General Public License                         -
# along with this program. If not, see <http://www.gnu.org/licenses/>.                             -
# L%                                                                                               -
#---------------------------------------------------------------------------------------------------

image: $IMAGE_DOCKER_MVN_JDK8

variables:
  # `showDateTime` will show the passed time in milliseconds. You need to specify `--batch-mode` to make this work.
  MAVEN_REPO_OPTS: "-Dmaven.repo.local=.m2/repository -s $MVN_SETTINGS -Dorg.slf4j.simpleLogger.showDateTime=true"
  # As of Maven 3.3.0 instead of this you may define these options in `.mvn/maven.config` so the same config is used
  # when running from the command line.
  # `installAtEnd` and `deployAtEnd`are only effective with recent version of the corresponding plugins.
  MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true"

stages:
- build

# Build, test and run Sonar analysis for dev branches
build:artifacts:
  stage: build
  script:
  - mvn $MAVEN_REPO_OPTS $MAVEN_CLI_OPTS clean $SONAR_PRE_BUILD_CMD verify $SONAR_POST_BUILD_CMD
  artifacts:
    #expire: never
    paths:
      - chvote-model-converter-docs/target/generated-docs/pdf/conversion-rules/conversion-rules.pdf
  cache:
    key: chvote-model-converter-$CI_COMMIT_REF_NAME
    paths:
    - .m2/repository/
  except:
  - tags

# Full build and artifact deployment for publishing branches
build:deploy:
  stage: build
  script:
  - mvn $MAVEN_REPO_OPTS $MAVEN_CLI_OPTS clean $SONAR_PRE_BUILD_CMD deploy $SONAR_POST_BUILD_CMD
  cache:
    key: chvote-model-converter-$CI_COMMIT_REF_NAME
    paths:
    - .m2/repository/
  only:
  - tags
